/* -=[ Ultra Power Effects Max II ]=-
 *
 * A simple program to put effects on the input device (mike for me)
 * and play the result on the output device.
 * Input and output are soundcard, which has to be full-duplex.
 *
 * This program is total free software, or simplier public domain.
 *
 * Enjoy yourself in this meaningless fucking world.
 * Fuck all the wars, for land or religion or whatever absurd abstraction you may think of.
 *
 * Sed - May 1999.
 * sed_sed@my-dejanews.com
 *--------------------------
 * This is the main file.
 */

#include "config.h"
#include "version.h"
#include "card.h"
#include "keyboard.h"

#include <string.h>
#include <stdlib.h>
#include <stdio.h>
#include <ctype.h>
#include <errno.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <fcntl.h>
#include <unistd.h>

void use_me(char *me)
{
  fprintf(stdout,
	  "-=[ Ultra Power Effects Max II ]=-\n"
	  "Options :\n"
	  "\t-h for help\n"
	  "\t-v for version\n"
	  "\t-d <file name> to dump it all to a raw file.\n"
	  "\t-i <vol> : set input volume (0-100)\n"
	  "\t-o <vol> : set output volume (0-100)\n"
	  "\t-b <bass> : set bass level (0-100)\n"
	  "\t-t <trebble> : set trebble level (0-100)\n"
	  "\t-f <frequence> : set sample frequence (8000-44100)\n"
	  "\t-8 : force 8 bits sample size output\n"
	  "\t-s : stereo\n"
	  "\t-m : mono (if both mono and stereo are given, the last is taken)\n"
	  "\t-n <number of fragments> : set the number of fragments\n"
	  "\t-r <fragment size> : set the size of a fragment (128, 256, 512, 1024, 2048, 4096, 8192, 16384, 32768, 65536, 131072)\n"
	  "\nDefault setting is :\n"
	  "\t16 bits output (can't change this default, must override at runtime if you want 8b)\n"
	  "\tinput volume = %d\n\toutput volume = %d\n\tbass = %d\n\ttrebble = %d\n\tfrequence = %d\n"
	  "\t%s output\n\tnumber of fragments = %d\n\tfragment size = %d\n",
	  DEFAULT_INPUT_VOLUME,
	  DEFAULT_OUTPUT_VOLUME,
	  DEFAULT_BASS,
	  DEFAULT_TREBBLE,
	  DEFAULT_FREQUENCE,
	  DEFAULT_MONO_STEREO==STEREO ? "stereo" : "mono",
	  DEFAULT_NB_FRAGMENTS,
	  DEFAULT_FRAGMENT_SIZE
	  );
}

void version_me(void)
{
  fprintf(stdout, "-=[ Ultra Power Effects Max II ]=- %s\n", VERSION);
}

int main(int nb, char **v)
{
  char *err=(char *)0;
  char *file=(char *)0;
  int output_file=0;
  int i, aux;
  int input_vol		= DEFAULT_INPUT_VOLUME;
  int output_vol	= DEFAULT_OUTPUT_VOLUME;
  int bass		= DEFAULT_BASS;
  int trebble		= DEFAULT_TREBBLE;
  int freq		= DEFAULT_FREQUENCE;
  int nb_frag		= DEFAULT_NB_FRAGMENTS;
  int frag_size		= DEFAULT_FRAGMENT_SIZE;
  int mono_stereo	= DEFAULT_MONO_STEREO;
  int bits		= 16;

  for (i=1; i<nb; i++) {
    if (!strcasecmp(v[i], "-h") || !strcasecmp(v[i], "--help")) {
      use_me(v[0]);
      return 0;
    }
    if (!strcasecmp(v[i], "-v") || !strcasecmp(v[i], "--version")) {
      version_me();
      return 0;
    }
  }

  for (i=1; i<nb; i++) {
    if (v[i][0]==0 || v[i][1]==0 || v[i][0]!='-' || v[i][2]!=0) {
      fprintf(stderr, "Warning : bad option \"%s\"\n", v[i]);
      continue;
    }

    switch(tolower(v[i][1])) {
      case 'd' :
	if (++i==nb) {
	  fprintf(stderr, "Warning : argument missing to option \"-%c\"\n", v[i-1][1]);
	  break;
	}
	file=v[i];
	if ((output_file=open(v[i], O_WRONLY|O_CREAT|O_TRUNC, 0644))==-1) {
	  perror("error while trying to create the dump file");
	  output_file=0;
	}
	break;
      case '8' :
	bits=8;
	break;
      case 'i' :
	if (++i==nb) {
	  fprintf(stderr, "Warning : argument missing to option \"-%c\"\n", v[i-1][1]);
	  break;
	}
	aux=strtol(v[i], &err, 0);
	if (errno==ERANGE || (err && *err!=0)) {
	  fprintf(stderr, "Warning : wrong argument to option \"-%c\"\n", v[i-1][1]);
	  break;
	}
	if (aux<0 || aux>100) {
	  fprintf(stderr, "Warning : value (%d) out of range for option  \"-%c\"\n", aux, v[i-1][1]);
	  break;
	}
	input_vol=aux;
	break;
      case 'o' :
	if (++i==nb) {
	  fprintf(stderr, "Warning : argument missing to option \"-%c\"\n", v[i-1][1]);
	  break;
	}
	aux=strtol(v[i], &err, 0);
	if (errno==ERANGE || (err && *err!=0)) {
	  fprintf(stderr, "Warning : wrong argument to option \"-%c\"\n", v[i-1][1]);
	  break;
	}
	if (aux<0 || aux>100) {
	  fprintf(stderr, "Warning : value (%d) out of range for option  \"-%c\"\n", aux, v[i-1][1]);
	  break;
	}
	output_vol=aux;
	break;
      case 'b' :
	if (++i==nb) {
	  fprintf(stderr, "Warning : argument missing to option \"-%c\"\n", v[i-1][1]);
	  break;
	}
	aux=strtol(v[i], &err, 0);
	if (errno==ERANGE || (err && *err!=0)) {
	  fprintf(stderr, "Warning : wrong argument to option \"-%c\"\n", v[i-1][1]);
	  break;
	}
	if (aux<0 || aux>100) {
	  fprintf(stderr, "Warning : value (%d) out of range for option  \"-%c\"\n", aux, v[i-1][1]);
	  break;
	}
	bass=aux;
	break;
      case 't' :
	if (++i==nb) {
	  fprintf(stderr, "Warning : argument missing to option \"-%c\"\n", v[i-1][1]);
	  break;
	}
	aux=strtol(v[i], &err, 0);
	if (errno==ERANGE || (err && *err!=0)) {
	  fprintf(stderr, "Warning : wrong argument to option \"-%c\"\n", v[i-1][1]);
	  break;
	}
	if (aux<0 || aux>100) {
	  fprintf(stderr, "Warning : value (%d) out of range for option  \"-%c\"\n", aux, v[i-1][1]);
	  break;
	}
	trebble=aux;
	break;
      case 'f' :
	if (++i==nb) {
	  fprintf(stderr, "Warning : argument missing to option \"-%c\"\n", v[i-1][1]);
	  break;
	}
	aux=strtol(v[i], &err, 0);
	if (errno==ERANGE || (err && *err!=0)) {
	  fprintf(stderr, "Warning : wrong argument to option \"-%c\"\n", v[i-1][1]);
	  break;
	}
	if (aux<8000 || aux>44100) {
	  fprintf(stderr, "Warning : value (%d) out of range for option  \"-%c\"\n", aux, v[i-1][1]);
	  break;
	}
	freq=aux;
	break;
      case 's' :
	mono_stereo=STEREO;
	break;
      case 'm' :
	mono_stereo=MONO;
	break;
      case 'n' :
	if (++i==nb) {
	  fprintf(stderr, "Warning : argument missing to option \"-%c\"\n", v[i-1][1]);
	  break;
	}
	aux=strtol(v[i], &err, 0);
	if (errno==ERANGE || (err && *err!=0)) {
	  fprintf(stderr, "Warning : wrong argument to option \"-%c\"\n", v[i-1][1]);
	  break;
	}
	if (aux<0 || aux>40) {
	  fprintf(stderr, "Warning : value (%d) out of range for option  \"-%c\"\n", aux, v[i-1][1]);
	  break;
	}
	nb_frag=aux;
	break;
      case 'r' :
	if (++i==nb) {
	  fprintf(stderr, "Warning : argument missing to option \"-%c\"\n", v[i-1][1]);
	  break;
	}
	aux=strtol(v[i], &err, 0);
	if (errno==ERANGE || (err && *err!=0)) {
	  fprintf(stderr, "Warning : wrong argument to option \"-%c\"\n", v[i-1][1]);
	  break;
	}
	{
	  int n;
	  for (n=0; n<11; n++)
	    if (fs[n]==aux) {
	      frag_size=aux;
	      break;
	    }
	  if (n==11)
	    fprintf(stderr, "Warning : value (%d) out of range for option  \"-%c\"\n", aux, v[i-1][1]);
	  break;
	}
	default :
	  fprintf(stderr, "Warning : bad option \"%s\"\n", v[i]);
    }
  }

  if (open_sound(input_vol, output_vol, bass, trebble, freq, bits, mono_stereo==STEREO, nb_frag, frag_size)==-1) {
    if (output_file)
      close(output_file);
    return -1;
  }

  if (set_keyboard()==-1) {
    if (output_file)
      close(output_file);
    close_sound();
    return -1;
  }

  fprintf(stdout,
	  "-=[ Ultra Power Effects Max II ]=-\n"
	  "Setting is :\n"
	  "\t%d bits output\n"
	  "\tinput volume = %d\n\toutput volume = %d\n\tbass = %d\n\ttrebble = %d\n\tfrequence = %d\n"
	  "\t%s output\n\tnumber of fragments = %d\n\tfragment size = %d\n",
	  bits,
	  input_vol,
	  output_vol,
	  bass,
	  trebble,
	  freq,
	  mono_stereo==STEREO ? "stereo" : "mono",
	  nb_frag,
	  frag_size
	  );
  if (output_file)
    fprintf(stdout, "\tdumping to \"%s\"\n", file);
  fflush(stdout);

  while(1) {
    int d;
    if (read_sound()==-1) {
      if (output_file)
	close(output_file);
      close_sound();
      reset_keyboard();
      return -1;
    }
    deal_with_sound();
    if (write_sound()==-1) {
      if (output_file)
	close(output_file);
      close_sound();
      reset_keyboard();
      return -1;
    }
    if (output_file) {
      extern char *buf;
      extern int size;
      if (write(output_file, buf, size)!=size) {
	close(output_file);
	close_sound();
	reset_keyboard();
	return -1;
      }
    }
    if ((d=deal_key_in())==1 || d==-1)
      break;
  }

  if (output_file)
    if (close(output_file)==-1)
      perror("error while closing the dump file, it might contain errors, do what you want with it\n");
  close_sound();
  reset_keyboard();
  fprintf(stdout, "Have a nice Linux.\n");
  fflush(stdout);
  return 0;
}
